/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.c
 * Copyright (C) 2019
 *
 * 8008135 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * 8008135 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*******************************************************************************/

/**** includes *****************************************************************
*******************************************************************************/
#include "p463unpr073c7.h"

/*******************************************************************************/


/***  FUNCTION  ****************************************************************
*          NAME:  wprotectionoff
*   DESCRIPTION:  turn page write protection off
*    PARAMETERS:  -
*       RETURNS:
*******************************************************************************/
void wprotectionoff(void){
	write_cr0(read_cr0() & (~WRITE_PROTECT_FLAG));
}

/***  FUNCTION  ****************************************************************
*          NAME:  wprotectionon
*   DESCRIPTION:  turn page write protection on
*    PARAMETERS:  -
*       RETURNS:
*******************************************************************************/

void wprotectionon(void){
	write_cr0(read_cr0() | WRITE_PROTECT_FLAG);
}
